!****************************************************************
! pdf\pdf_sheet.prg
! ADT-program used by publisher to select sheets
! Vertex Systems Oy / 2009-09-17
!
! In:
!   PDFVXP_PICW     -> width of drawing limits 
!   PDFVXP_PICH     -> height of drawing limits
!   PDFVXP_FILE     -> file name
!
! Out:
!   PDFVXP_SHTW     -> width of sheet
!   PDFVXP_SHTH     -> height of sheet
!   PDFVXP_SHTFOUND -> sheet was found from predefined sheet table
!   
!****************************************************************
! debug ./pdf_sheet.dbg
!
Width = get("PDFVXP_PICW")
Height = get("PDFVXP_PICH")
! 
! FilePath$ = get("PDFVXP_FILE")
! File$ = filepath_file(FilePath$)
!
Metric = 0
One = dwg_to_mm(1.0)
if (One == 1.0) then
  Metric = 1
endif
!
Tole = mm_to_dwg(1.001);! 1 is for 0.5mm drawing limits and 0.001 is EPS2
Width2 = Width-Tole
Height2 = Height-Tole
!
if Metric then
  Sheet0 = 9
  SheetWidth(1) =   297; SheetHeight(1) =   210 ;! A4
  SheetWidth(2) = 2*210; SheetHeight(2) =   297 ;! A3
  SheetWidth(3) = 3*210; SheetHeight(3) =   297 ;! 3xA4
  SheetWidth(4) = 4*210; SheetHeight(4) =   297 ;! 4xA4
  SheetWidth(5) = 5*210; SheetHeight(5) =   297 ;! 5xA4
  SheetWidth(6) = 6*210; SheetHeight(6) =   297 ;! 6xA4
  SheetWidth(7) = 2*297; SheetHeight(7) = 2*210 ;! A2
  SheetWidth(8) = 4*210; SheetHeight(8) = 2*297 ;! A1
  SheetWidth(9) = 4*297; SheetHeight(9) = 4*210; ! A0
else
  Sheet0 = 5
  SheetWidth(1) = 11; SheetHeight(1) = 8.5 ;! A
  SheetWidth(2) = 17; SheetHeight(2) = 11  ;! B
  SheetWidth(3) = 22; SheetHeight(3) = 17  ;! C
  SheetWidth(4) = 36; SheetHeight(4) = 24  ;! D
  SheetWidth(5) = 42; SheetHeight(5) = 30  ;! E
endif

! Find smallest sheet on which the drawing fits. Both
! portrait and landscape orientations are checked.      
J = 0
loop
  J = J+1
  exitif J>Sheet0
  exitif Width2<SheetWidth(J)  and Height2<SheetHeight(J)
  exitif Width2<SheetHeight(J) and Height2<SheetWidth(J)
endloop

if J <= Sheet0 then
  ShFound = 1
  if Width2<SheetWidth(J) and Height2<SheetHeight(J) then
    ShWidth = SheetWidth(J)
    ShHeight = SheetHeight(J)
  else
    ShWidth = SheetHeight(J)
    ShHeight = SheetWidth(J)
  endif
else
  ShFound = 0
  ShWidth = Width
  ShHeight = Height
endif

set "PDFVXP_SHTW" ShWidth
set "PDFVXP_SHTH" ShHeight
set "PDFVXP_SHTFOUND" ShFound
