# attributes on
!***************************************************************
! L thin sheet with small flanges at ends
!
!
! Cross section of the profile
! Angles Angle(A), UpperAngle(T) and LowerAngle(B) marked as positive angles
!
!   T|
! 5/\|
! 4\ |
!  | | A
!  | |______
!  |_____ \B
!  1    2\/ 
!         3   
!***************************************************************
!
!debug ./baseprof
!
Width = #WIDTH#
Height= #HEIGHT#
Angle = #ANGLE#
!
Thick=get("THICKNESS")

UpperLen=get("UPPERLEN")
UpperAng=get("UPPERANGLE")

LowerLen=get("LOWERLEN")
LowerAng=get("LOWERANGLE")
!
! Angle was angle between lines.
! Now it's absolute angle
Angle=90-Angle

! UpperAng was angle between vertical and flange.
! Now it's absolute angle
UpperAng=UpperAng+90

! LowerAng was angle between horizontal and flange.
! Now it's absolute angle
LowerAng=-LowerAng

! offset_line fails if identical points on the original line
if LowerLen==0 then
  LowerAng=0
  LowerLen=1
  Width=Width-LowerLen
endif

if UpperLen==0 then
  UpperAng=90
  UpperLen=1
  Height=Height-UpperLen
endif
 

point(1) 0,0
point(2) xcoord(1)+Width    *cos(Angle),         ycoord(1)+Width    *sin(Angle)
point(3) xcoord(2)+LowerLen *cos(Angle+LowerAng),ycoord(2)+LowerLen *sin(Angle+LowerAng)
point(4) xcoord(1),                              ycoord(1)+Height
point(5) xcoord(4)+UpperLen *cos(UpperAng),      ycoord(4)+UpperLen *sin(UpperAng)

line(1) P3,P2,P1,P4,P5
offset_line(3) L1,Thick

get_line_point(20) L3, 5
line(2) P20,P5

get_line_point(10) L3, 1
line(4) P10,P3

hatch L1,L2,L3,L4
!
